-- Author      : CY Nip
-- Create Date : 08/01/2011 22:58:25

local L = MyLocalization;

local DoomFreeConfig_temp_EndCap;
local DoomFreeConfig_temp_InterruptAnnounce;
local DoomFreeConfig_temp_PlayerX;
local DoomFreeConfig_temp_PlayerY;
local DoomFreeConfig_temp_TargetX;
local DoomFreeConfig_temp_TargetY;
local DoomFreeConfig_temp_PetX;
local DoomFreeConfig_temp_PetY;

local DoomFreeConfig_temp_InitFlag = false;

function DoomFree_Frame_Options_OnLoad(frm)
  frm.name = "DoomFree";
  frm.okay = function () DoomFree_Frame_Options_Close(); end;
  frm.cancel = function () DoomFree_Frame_Options_Cancel(); end;

  InterfaceOptions_AddCategory(frm);

  getglobal(frm:GetName().."_lbl_author"):SetText("|cFF555555By "..GetAddOnMetadata("DoomFree", "Author"));
  getglobal(frm:GetName().."_lbl_title"):SetText("DoomFree |cFF444444"..GetAddOnMetadata("DoomFree", "Version"));
  getglobal(frm:GetName().."_lbl_description"):SetText(L['lbl_description']);

  getglobal(frm:GetName().."_cbox_endcap".."Text"):SetText(L['lbl_endcap']);

  getglobal(frm:GetName().."_slider_playerx"):SetMinMaxValues(-640, -100);
  getglobal(frm:GetName().."_slider_playerx"):SetValueStep(10);
  getglobal(frm:GetName().."_slider_playerx".."Low"):SetText("-640");
  getglobal(frm:GetName().."_slider_playerx".."High"):SetText("-100");
  getglobal(frm:GetName().."_slider_playerx".."Text"):SetText(L['lbl_playerx']);

  getglobal(frm:GetName().."_slider_playery"):SetMinMaxValues(-100, 100);
  getglobal(frm:GetName().."_slider_playery"):SetValueStep(10);
  getglobal(frm:GetName().."_slider_playery".."Low"):SetText("-100");
  getglobal(frm:GetName().."_slider_playery".."High"):SetText("100");
  getglobal(frm:GetName().."_slider_playery".."Text"):SetText(L['lbl_playery']);

  getglobal(frm:GetName().."_slider_targetx"):SetMinMaxValues(100, 640);
  getglobal(frm:GetName().."_slider_targetx"):SetValueStep(10);
  getglobal(frm:GetName().."_slider_targetx".."Low"):SetText("100");
  getglobal(frm:GetName().."_slider_targetx".."High"):SetText("640");
  getglobal(frm:GetName().."_slider_targetx".."Text"):SetText(L['lbl_targetx']);

  getglobal(frm:GetName().."_slider_targety"):SetMinMaxValues(-100, 100);
  getglobal(frm:GetName().."_slider_targety"):SetValueStep(10);
  getglobal(frm:GetName().."_slider_targety".."Low"):SetText("-100");
  getglobal(frm:GetName().."_slider_targety".."High"):SetText("100");
  getglobal(frm:GetName().."_slider_targety".."Text"):SetText(L['lbl_targety']);

  getglobal(frm:GetName().."_slider_petx"):SetMinMaxValues(-640, -100);
  getglobal(frm:GetName().."_slider_petx"):SetValueStep(10);
  getglobal(frm:GetName().."_slider_petx".."Low"):SetText("-640");
  getglobal(frm:GetName().."_slider_petx".."High"):SetText("-100");
  getglobal(frm:GetName().."_slider_petx".."Text"):SetText(L['lbl_petx']);

  getglobal(frm:GetName().."_slider_pety"):SetMinMaxValues(-100, 100);
  getglobal(frm:GetName().."_slider_pety"):SetValueStep(10);
  getglobal(frm:GetName().."_slider_pety".."Low"):SetText("-100");
  getglobal(frm:GetName().."_slider_pety".."High"):SetText("100");
  getglobal(frm:GetName().."_slider_pety".."Text"):SetText(L['lbl_pety']);

  getglobal(frm:GetName().."_cbox_interruptannounce".."Text"):SetText(L['lbl_interruptannounce']);

end

function DoomFree_Frame_Options_OnShow(frm)

  -- moved here to avoid bug?
  -- read settings from profile, and change our checkbuttons and slider to represent them
  getglobal(frm:GetName().."_cbox_endcap"):SetChecked( DoomFreeConfig.EndCap);
  getglobal(frm:GetName().."_cbox_interruptannounce"):SetChecked( DoomFreeConfig.InterruptAnnounce);

  getglobal(frm:GetName().."_slider_playerx"):SetValue( DoomFreeConfig.PlayerX);
  getglobal(frm:GetName().."_slider_playery"):SetValue( DoomFreeConfig.PlayerY);
  getglobal(frm:GetName().."_slider_targetx"):SetValue( DoomFreeConfig.TargetX);
  getglobal(frm:GetName().."_slider_targety"):SetValue( DoomFreeConfig.TargetY);
  getglobal(frm:GetName().."_slider_petx"):SetValue( DoomFreeConfig.PetX);
  getglobal(frm:GetName().."_slider_pety"):SetValue( DoomFreeConfig.PetY);

  DoomFree_Frame_Options_Lbl_Update(frm);

  -- save the settings in case user cancels out of the options dialog
  DoomFreeConfig_temp_EndCap = DoomFreeConfig.EndCap;
  DoomFreeConfig_temp_InterruptAnnounce = DoomFreeConfig.InterruptAnnounce;
  DoomFreeConfig_temp_PlayerX = DoomFreeConfig.PlayerX;
  DoomFreeConfig_temp_PlayerY = DoomFreeConfig.PlayerY;
  DoomFreeConfig_temp_TargetX = DoomFreeConfig.TargetX;
  DoomFreeConfig_temp_TargetY = DoomFreeConfig.TargetY;
  DoomFreeConfig_temp_PetX = DoomFreeConfig.PetX;
  DoomFreeConfig_temp_PetY = DoomFreeConfig.PetY;

  DoomFreeConfig_temp_InitFlag = true;
end

function DoomFree_Frame_Options_Lbl_Update(frm)
  getglobal(frm:GetName().."_lbl_playerx"):SetText( DoomFreeConfig.PlayerX);
  getglobal(frm:GetName().."_lbl_playery"):SetText( DoomFreeConfig.PlayerY);
  getglobal(frm:GetName().."_lbl_targetx"):SetText( DoomFreeConfig.TargetX);
  getglobal(frm:GetName().."_lbl_targety"):SetText( DoomFreeConfig.TargetY);
  getglobal(frm:GetName().."_lbl_petx"):SetText( DoomFreeConfig.PetX);
  getglobal(frm:GetName().."_lbl_pety"):SetText( DoomFreeConfig.PetY);
end

function DoomFree_Frame_Options_OnEvent(frm, ...)

  local arg1 = ...

  -- every time an option box is changed update the variable it represents
  if ( frm:GetName() == (frm:GetParent():GetName().."_cbox_endcap" ) ) then
    DoomFreeConfig.EndCap = frm:GetChecked()~=nil;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_cbox_interruptannounce" ) ) then
    DoomFreeConfig.InterruptAnnounce = frm:GetChecked()~=nil;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_slider_playerx" ) ) then
    DoomFreeConfig.PlayerX = arg1;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_slider_playery" ) ) then
    DoomFreeConfig.PlayerY = arg1;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_slider_targetx" ) ) then
    DoomFreeConfig.TargetX = arg1;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_slider_targety" ) ) then
    DoomFreeConfig.TargetY = arg1;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_slider_petx" ) ) then
    DoomFreeConfig.PetX = arg1;
  elseif ( frm:GetName() == (frm:GetParent():GetName().."_slider_pety" ) ) then
    DoomFreeConfig.PetY = arg1;
  else
    DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Frame_Options_OnEvent unhandled "..frm:GetName());
  end

  DoomFree_Frame_Options_Lbl_Update(frm:GetParent());

  DoomFreeConfig_Apply();
  -- realtime display change for easier configuration
  DoomFree_UpdateDisplay();
end

function DoomFree_Frame_Options_Close()
  DoomFreeConfig_Apply();
  DoomFree_UpdateDisplay();
  DoomFree_UpdateRegisteredEvents();
end

function DoomFree_Frame_Options_Cancel()
  -- cancel the changes by reverting to the last temp settings stored
  if (DoomFreeConfig_temp_InitFlag) then
    DoomFreeConfig.EndCap = DoomFreeConfig_temp_EndCap;
    DoomFreeConfig.InterruptAnnounce = DoomFreeConfig_temp_InterruptAnnounce;
    DoomFreeConfig.PlayerX = DoomFreeConfig_temp_PlayerX;
    DoomFreeConfig.PlayerY = DoomFreeConfig_temp_PlayerY;
    DoomFreeConfig.TargetX = DoomFreeConfig_temp_TargetX;
    DoomFreeConfig.TargetY = DoomFreeConfig_temp_TargetY;
    DoomFreeConfig.PetX = DoomFreeConfig_temp_PetX;
    DoomFreeConfig.PetY = DoomFreeConfig_temp_PetY;
  end

  DoomFreeConfig_Apply();
  DoomFree_UpdateDisplay();
  DoomFree_UpdateRegisteredEvents();
end